﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter;

namespace CellValueNotUpdateReproduce
{
    /// <summary>
    /// Interaction logic for Page1.xaml
    /// </summary>
    public partial class Page1 : Page
    {
        XamDataGrid grid = new XamDataGrid();
        ObservableCollection<Student> Students = new ObservableCollection<Student>();
        ObservableCollection<MarkInfo> markSet1 = new ObservableCollection<MarkInfo>();
        ObservableCollection<MarkInfo> markSet2 = new ObservableCollection<MarkInfo>();
        public Page1()
        {
            InitializeComponent();
        }

        private void Page_Loaded(object sender, RoutedEventArgs e)
        {
            this.rootGrid.Children.Add(this.grid);
            Grid.SetRow(this.grid, 1);

            this.grid.FieldLayoutSettings.AutoGenerateFields = true;
            this.grid.FieldSettings.AllowEdit = false;

            markSet1.Add(new MarkInfo() { Subject = "Maths", Mark = 100 });
            markSet1.Add(new MarkInfo() { Subject = "Physics", Mark = 120 });
            markSet1.Add(new MarkInfo() { Subject = "Chemistry", Mark = 80 });

            markSet2.Add(new MarkInfo() { Subject = "Maths", Mark = 90 });
            markSet2.Add(new MarkInfo() { Subject = "Physics", Mark = 70 });
            markSet2.Add(new MarkInfo() { Subject = "Chemistry", Mark = 60 });

            Student student1 = new Student("101", "Abc", markSet1);
            Student student2 = new Student("102", "Xyz", markSet2);

            this.Students.Add(student1);
            this.Students.Add(student2);

            this.grid.InitializeRecord += new EventHandler<Infragistics.Windows.DataPresenter.Events.InitializeRecordEventArgs>(grid_InitializeRecord);

            this.grid.DataSource = this.Students;
        }

        void grid_InitializeRecord(object sender, Infragistics.Windows.DataPresenter.Events.InitializeRecordEventArgs e)
        {
            e.Record.IsExpanded = true;            
        }

        private void b2_Click(object sender, RoutedEventArgs e)
        {
            this.markSet1[0].Mark += 10;
            this.markSet1[1].Mark += 10;
            this.markSet1[2].Mark += 10;
        }
    }

    public class Student : INotifyPropertyChanged
    {
        private string studentID = string.Empty;
        private string studentName = string.Empty;
        private ObservableCollection<MarkInfo> marks = new ObservableCollection<MarkInfo>();

        public Student(string sID, string sName, ObservableCollection<MarkInfo> sMark)
        {
            this.StudentID = sID;
            this.StudentName = sName;
            this.Marks = sMark;
        }

        public ObservableCollection<MarkInfo> Marks
        {
            get
            {
                return this.marks;
            }
            set
            {
                this.marks = value;
                this.NotifyPropertyChanged("Marks");
            }
        }

        public string StudentName
        {
            get
            {
                return this.studentName;
            }
            set
            {
                this.studentName = value;
                this.NotifyPropertyChanged("StudentName");
            }
        }

        public string StudentID
        {
            get
            {
                return this.studentID;
            }
            set
            {
                this.studentID = value;
                this.NotifyPropertyChanged("StudentID");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        /// <summary>
        /// Function for NotifyPropertyChanged
        /// </summary>
        private void NotifyPropertyChanged(string info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
    }

    public class MarkInfo : INotifyPropertyChanged
    {
        private string subject = string.Empty;
        private int mark = 0;

        public string Subject
        {
            get
            {
                return this.subject;
            }
            set
            {
                this.subject = value;
                this.NotifyPropertyChanged("Subject");
            }            
        }

        public int Mark
        {
            get
            {
                return this.mark;
            }
            set
            {
                this.mark = value;
                this.NotifyPropertyChanged("Mark");
            }
        }

        #region INotifyPropertyChanged Members
        public event PropertyChangedEventHandler PropertyChanged;

        /// <summary>
        /// Function for NotifyPropertyChanged
        /// </summary>
        private void NotifyPropertyChanged(string info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
        #endregion
    }


}
